diff --git a/krita/image/kis_image.cc b/krita/image/kis_image.cc
index 94761ca..d62e54d 100644
--- a/krita/image/kis_image.cc
+++ b/krita/image/kis_image.cc
@@ -842,6 +842,17 @@ void KisImage::renderToPainter(qint32 srcX,
     painter.drawImage(dstX, dstY, image, 0, 0, width, height);
 }
 
+QImage KisImage::convertToQImage(QRect imageRect,
+                                 const KoColorProfile * profile)
+{
+    qint32 x;
+    qint32 y;
+    qint32 w;
+    qint32 h;
+    imageRect.getRect(&x, &y, &w, &h);
+    return convertToQImage(x, y, w, h, profile);
+}
+
 QImage KisImage::convertToQImage(qint32 x,
                                  qint32 y,
                                  qint32 w,
diff --git a/krita/image/kis_image.h b/krita/image/kis_image.h
index 5b7fec7..e83af97 100644
--- a/krita/image/kis_image.h
+++ b/krita/image/kis_image.h
@@ -99,6 +99,13 @@ public:
                            qint32 height,
                            const KoColorProfile * profile);
 
+    /**
+     * Render the projection onto a QImage.
+     * (this is an overloaded function)
+     */
+    QImage convertToQImage(QRect imageRect,
+                           const KoColorProfile * profile);
+
 
     /**
      * XXX: docs!
diff --git a/krita/image/kis_projection.cc b/krita/image/kis_projection.cc
index 3e5e551..829d3ce 100644
--- a/krita/image/kis_projection.cc
+++ b/krita/image/kis_projection.cc
@@ -65,8 +65,11 @@ KisProjection::KisProjection(KisImageWSP image)
             m_d->updater, SLOT(startFullRefresh(KisNodeSP, QRect)),
             Qt::BlockingQueuedConnection);
 
-    connect(this, SIGNAL(sigUpdateProjection(KisNodeSP, QRect, QRect)), m_d->updater, SLOT(startUpdate(KisNodeSP, QRect, QRect)));
-    connect(m_d->updater, SIGNAL(updateDone(QRect)), m_d->image, SLOT(slotProjectionUpdated(QRect)));
+    connect(this, SIGNAL(sigUpdateProjection(KisNodeSP, QRect, QRect)),
+            m_d->updater, SLOT(startUpdate(KisNodeSP, QRect, QRect)));
+    connect(m_d->updater, SIGNAL(updateDone(QRect)),
+            m_d->image, SLOT(slotProjectionUpdated(QRect)),
+            Qt::DirectConnection);
 }
 
 
diff --git a/krita/ui/CMakeLists.txt b/krita/ui/CMakeLists.txt
index 28ba624..81dc8fa 100644
--- a/krita/ui/CMakeLists.txt
+++ b/krita/ui/CMakeLists.txt
@@ -28,6 +28,8 @@ set(kritaui_LIB_SRCS
     canvas/kis_projection_cache.cpp
     canvas/kis_qpainter_canvas.cpp
     canvas/kis_projection_backend.cpp
+    canvas/kis_update_info.cpp
+    canvas/kis_image_patch.cpp
     canvas/kis_image_pyramid.cpp
     dialogs/kis_dlg_adj_layer_props.cc 
     dialogs/kis_dlg_adjustment_layer.cc
diff --git a/krita/ui/canvas/kis_canvas2.cpp b/krita/ui/canvas/kis_canvas2.cpp
index bf93e75..623d44b 100644
--- a/krita/ui/canvas/kis_canvas2.cpp
+++ b/krita/ui/canvas/kis_canvas2.cpp
@@ -112,7 +112,8 @@ KisCanvas2::KisCanvas2(KoViewConverter * viewConverter, KisView2 * view, KoShape
     : KoCanvasBase(sc)
     , m_d(new KisCanvas2Private(this, viewConverter, view))
 {
-    createCanvas();
+    KisConfig cfg;
+    createCanvas(cfg.useOpenGL());
     connect(view->canvasController(), SIGNAL(moveDocumentOffset(const QPoint&)), SLOT(documentOffsetMoved(const QPoint&)));
     connect(KisConfigNotifier::instance(), SIGNAL(configChanged()), SLOT(slotConfigChanged()));
     connect(this, SIGNAL(canvasDestroyed(QWidget *)), this, SLOT(slotCanvasDestroyed(QWidget *)));
@@ -125,6 +126,8 @@ KisCanvas2::~KisCanvas2()
 
 void KisCanvas2::setCanvasWidget(QWidget * widget)
 {
+    connect(widget, SIGNAL(documentOriginChanged(const QPoint&)), this, SLOT(updateRulers())); 
+
     KisAbstractCanvasWidget * tmp = dynamic_cast<KisAbstractCanvasWidget*>(widget);
     Q_ASSERT_X(tmp, "setCanvasWidget", "Cannot cast the widget to a KisAbstractCanvasWidget");
     emit canvasDestroyed(widget);
@@ -166,6 +169,11 @@ bool KisCanvas2::isCanvasMirrored()
     return m_d->mirrorMode;
 }
 
+void KisCanvas2::mirrorCanvas(bool enable)
+{
+    m_d->mirrorMode = enable;
+    updateCanvas();
+}
 
 void KisCanvas2::addCommand(QUndoCommand *command)
 {
@@ -207,16 +215,6 @@ KoShapeManager * KisCanvas2::globalShapeManager() const
     return m_d->shapeManager;
 }
 
-void KisCanvas2::updateCanvas(const QRectF& rc)
-{
-    // updateCanvas is called from tools, never from the projection
-    // updates, so no need to prescale!
-    QRect vRect = viewRectFromDoc(rc);
-    if (!vRect.isEmpty()) {
-        m_d->canvasWidget->widget()->update(vRect);
-    }
-}
-
 void KisCanvas2::updateInputMethodInfo()
 {
     // TODO call (the protected) QWidget::updateMicroFocus() on the proper canvas widget...
@@ -250,9 +248,6 @@ KoToolProxy * KisCanvas2::toolProxy() const
 
 void KisCanvas2::createQPainterCanvas()
 {
-#ifdef HAVE_OPENGL
-    m_d->openGLImageTextures = 0;
-#endif
     m_d->currentCanvasIsOpenGL = false;
 
     KisQPainterCanvas * canvasWidget = new KisQPainterCanvas(this, m_d->view);
@@ -260,181 +255,238 @@ void KisCanvas2::createQPainterCanvas()
     m_d->prescaledProjection->setViewConverter(m_d->viewConverter);
     m_d->prescaledProjection->setMonitorProfile(monitorProfile());
     canvasWidget->setPrescaledProjection(m_d->prescaledProjection);
-
-    connect(canvasWidget, SIGNAL(documentOriginChanged(const QPoint&)), this, SLOT(updateRulers()));
-
     setCanvasWidget(canvasWidget);
 }
 
 void KisCanvas2::createOpenGLCanvas()
 {
 #ifdef HAVE_OPENGL
-    if (QGLFormat::hasOpenGL()) {
-        // XXX: The image isn't done loading here!
-        m_d->openGLImageTextures = KisOpenGLImageTextures::getImageTextures(m_d->view->image(), m_d->monitorProfile);
-        KisOpenGLCanvas2 * canvasWidget = new KisOpenGLCanvas2(this, m_d->view, m_d->openGLImageTextures);
-        setCanvasWidget(canvasWidget);
-        m_d->currentCanvasIsOpenGL = true;
-        m_d->currentCanvasUsesOpenGLShaders = m_d->openGLImageTextures->usingHDRExposureProgram();
-
-        connect(canvasWidget, SIGNAL(documentOriginChanged(const QPoint&)), this, SLOT(updateRulers()));
+    m_d->currentCanvasIsOpenGL = true;
 
-    } else {
-        warnKrita << "Tried to create OpenGL widget when system doesn't have OpenGL\n";
-        createQPainterCanvas();
-    }
+    // XXX: The image isn't done loading here!
+    m_d->openGLImageTextures = KisOpenGLImageTextures::getImageTextures(m_d->view->image(), m_d->monitorProfile);
+    KisOpenGLCanvas2 * canvasWidget = new KisOpenGLCanvas2(this, m_d->view, m_d->openGLImageTextures);
+    m_d->currentCanvasUsesOpenGLShaders = m_d->openGLImageTextures->usingHDRExposureProgram();
+    setCanvasWidget(canvasWidget);
+#else
+    qFatal() << "Bad use of createOpenGLCanvas(). It shouldn't have happened =(";
 #endif
 }
 
-void KisCanvas2::createCanvas()
+void KisCanvas2::createCanvas(bool useOpenGL)
 {
     KisConfig cfg;
     slotSetDisplayProfile(KoColorSpaceRegistry::instance()->profileByName(cfg.monitorProfile()));
 
-    if (cfg.useOpenGL()) {
+    if (useOpenGL) {
 #ifdef HAVE_OPENGL
-        createOpenGLCanvas();
+        if (QGLFormat::hasOpenGL()) {
+            createOpenGLCanvas();
+        } else {
+            warnKrita << "Tried to create OpenGL widget when system doesn't have OpenGL\n";
+            createQPainterCanvas();
+        }
 #else
         warnKrita << "OpenGL requested while its not available, starting qpainter canvas";
         createQPainterCanvas();
 #endif
     } else {
+#ifdef HAVE_OPENGL
+        // Free shared pointer
+        m_d->openGLImageTextures = 0;
+#endif
         createQPainterCanvas();
     }
-
 }
 
-KisView2* KisCanvas2::view()
+void KisCanvas2::connectCurrentImage()
 {
-    return m_d->view;
+
+    if (m_d->currentCanvasIsOpenGL) {
+#ifdef HAVE_OPENGL
+        Q_ASSERT(m_d->openGLImageTextures);
+
+        connect(m_d->view->image(), SIGNAL(sigSizeChanged(qint32, qint32)),
+                m_d->openGLImageTextures, SLOT(slotImageSizeChanged(qint32, qint32)));
+#else
+        qFatal() << "Bad use of connectCurrentImage(). It shouldn't have happened =(";
+#endif
+    } else {
+        connect(m_d->view->image(), SIGNAL(sigSizeChanged(qint32, qint32)),
+                SLOT(setImageSize(qint32, qint32)));
+
+        Q_ASSERT(m_d->prescaledProjection);
+        m_d->prescaledProjection->setImage(m_d->view->image());
+
+    }
+
+    connect(m_d->view->image(), SIGNAL(sigImageUpdated(const QRect &)),
+            SLOT(startUpdateCanvasProjection(const QRect &)),
+            Qt::DirectConnection);
+    connect(this, SIGNAL(sigCanvasCacheUpdated(KisUpdateInfoSP)),
+            this, SLOT(updateCanvasProjection(KisUpdateInfoSP)));
+
+    emit imageChanged(m_d->view->image());
 }
 
+void KisCanvas2::disconnectCurrentImage()
+{
+    if (m_d->currentCanvasIsOpenGL) {
+#ifdef HAVE_OPENGL
+        Q_ASSERT(m_d->openGLImageTextures);
+        m_d->openGLImageTextures->disconnect(this);
+        m_d->openGLImageTextures->disconnect(m_d->view->image());
+#else
+        qFatal() << "Bad use of disconnectCurrentImage(). It shouldn't have happened =(";
+#endif
+    }
 
-QRect KisCanvas2::viewRectFromDoc(const QRectF & rc)
+    disconnect(SIGNAL(sigImageUpdated(const QRect &)));
+    disconnect(SIGNAL(sigCanvasCacheUpdated(KisUpdateInfoSP)));
+
+    // for sigSizeChanged()
+    m_d->view->image()->disconnect(this);
+}
+
+void KisCanvas2::resetCanvas(bool useOpenGL)
 {
-    QRect viewRect = m_d->viewConverter->documentToView(rc).toAlignedRect();
-    viewRect = viewRect.translated(-m_d->documentOffset);
-    // comment out this line if zou want to see the preview outside of the canvas
-    // viewRect = viewRect.intersected(QRect(0, 0, m_d->canvasWidget->widget()->width(), m_d->canvasWidget->widget()->height()));
-    viewRect.translate(documentOrigin());
-    return viewRect;
+#ifdef HAVE_OPENGL
+    KisConfig cfg;
+
+    if (   (useOpenGL != m_d->currentCanvasIsOpenGL)
+        || (   m_d->currentCanvasIsOpenGL
+               && (cfg.useOpenGLShaders() != m_d->currentCanvasUsesOpenGLShaders))) {
+
+        disconnectCurrentImage();
+        createCanvas(useOpenGL);
+        connectCurrentImage();
+    }
+
+    if (useOpenGL) {
+        Q_ASSERT(m_d->openGLImageTextures);
+        m_d->openGLImageTextures->setMonitorProfile(monitorProfile());
+    } else {
+        if (image()) {
+            startUpdateCanvasProjection(image()->bounds());
+        }
+    }
+
+#endif
+    m_d->canvasWidget->widget()->update();
 }
 
+void KisCanvas2::startUpdateCanvasProjection(const QRect & rc)
+{
+    if (m_d->currentCanvasIsOpenGL) {
+#ifdef HAVE_OPENGL
+        Q_ASSERT(m_d->openGLImageTextures);
+        KisUpdateInfoSP info = m_d->openGLImageTextures->updateCache(rc);
+
+        emit sigCanvasCacheUpdated(info);
+#else
+        Q_ASSERT_X(0, "startUpdateCanvasProjection()", "Bad use of startUpdateCanvasProjection(). It shouldn't have happened =(");
+#endif
+    } else {
+        Q_ASSERT(m_d->prescaledProjection);
+        KisUpdateInfoSP info = m_d->prescaledProjection->updateCache(rc);
 
-void KisCanvas2::updateCanvasProjection(const QRect & rc)
+        emit sigCanvasCacheUpdated(info);
+    }
+
+
+}
+
+void KisCanvas2::updateCanvasProjection(KisUpdateInfoSP info)
 {
-    if (m_d->prescaledProjection) {
-        QRect vRect = m_d->prescaledProjection->updateCanvasProjection(rc);
-        
-        // attemp to mirror the rectangle in image coordinates, this does not work to fix correct updates in mirroring mode, 
-        // so use full canvas update so far 
-        // kDebug() << vRect;
-        // vRect = QRect(image()->width() - vRect.x() - vRect.width(),vRect.top(),vRect.width(), vRect.height());
-        // kDebug() << vRect;
-        // kDebug();
+    if (m_d->currentCanvasIsOpenGL) {
+#ifdef HAVE_OPENGL
+        Q_ASSERT(m_d->openGLImageTextures);
+        m_d->openGLImageTextures->recalculateCache(info);
+
+        /**
+         * FIXME: Please not update entire canvas
+         * Implement info->dirtyViewportRect()
+         */
+        m_d->canvasWidget->widget()->update();
+#else
+        Q_ASSERT_X(0, "updateCanvasProjection()", "Bad use of updateCanvasProjection(). It shouldn't have happened =(");
+#endif
+    }
+    else {
+
+        // See comment in startUpdateCanvasProjection()
+        Q_ASSERT(m_d->prescaledProjection);
+
+        m_d->prescaledProjection->recalculateCache(info);
+
+        QRect vRect = info->dirtyViewportRect();
         if (m_d->mirrorMode){
             m_d->canvasWidget->widget()->update();
-        }else
-        if (!vRect.isEmpty()) {
-            vRect.translate( m_d->canvasWidget->documentOrigin());
+        }else if (!vRect.isEmpty()) {
+            vRect.translate(m_d->canvasWidget->documentOrigin());
             m_d->canvasWidget->widget()->update(vRect);
         }
     }
 }
 
-
 void KisCanvas2::updateCanvas()
 {
     m_d->canvasWidget->widget()->update();
 }
 
-
-KisImageWSP KisCanvas2::image()
+void KisCanvas2::updateCanvas(const QRectF& rc)
 {
-    return m_d->view->image();
-
+    // updateCanvas is called from tools, never from the projection
+    // updates, so no need to prescale!
+    QRect vRect = viewRectFromDoc(rc);
+    if (!vRect.isEmpty()) {
+        m_d->canvasWidget->widget()->update(vRect);
+    }
 }
 
-KoColorProfile *  KisCanvas2::monitorProfile()
+void KisCanvas2::preScale()
 {
-    return m_d->monitorProfile;
+    if (!m_d->currentCanvasIsOpenGL) {
+        Q_ASSERT(m_d->prescaledProjection);
+        m_d->prescaledProjection->preScale();
+    }
 }
 
-KisImageWSP KisCanvas2::currentImage()
+QRect KisCanvas2::viewRectFromDoc(const QRectF & rc)
 {
-    return m_d->view->image();
+    QRect viewRect = m_d->viewConverter->documentToView(rc).toAlignedRect();
+    viewRect = viewRect.translated(-m_d->documentOffset);
+    // comment out this line if you want to see the preview outside of the canvas
+    // viewRect = viewRect.intersected(QRect(0, 0, m_d->canvasWidget->widget()->width(), m_d->canvasWidget->widget()->height()));
+    viewRect.translate(documentOrigin());
+    return viewRect;
 }
 
-void KisCanvas2::setImageSize(qint32 w, qint32 h)
+KoColorProfile *  KisCanvas2::monitorProfile()
 {
-    if (m_d->prescaledProjection)
-        m_d->prescaledProjection->setImageSize(w, h);
+    return m_d->monitorProfile;
 }
 
-void KisCanvas2::connectCurrentImage()
+KisView2* KisCanvas2::view()
 {
-#ifdef HAVE_OPENGL
-    if (m_d->openGLImageTextures) {
-        connect(m_d->openGLImageTextures, SIGNAL(sigImageUpdated(const QRect &)), SLOT(updateCanvas()));
-        connect(m_d->openGLImageTextures, SIGNAL(sigSizeChanged(qint32, qint32)), SLOT(setImageSize(qint32, qint32)));
-    } else {
-#endif
-        connect(m_d->view->image(), SIGNAL(sigImageUpdated(const QRect &)), SLOT(updateCanvasProjection(const QRect &)));
-        connect(m_d->view->image(), SIGNAL(sigSizeChanged(qint32, qint32)), SLOT(setImageSize(qint32, qint32)));
+    return m_d->view;
+}
 
-        if (m_d->prescaledProjection) {
-            m_d->prescaledProjection->setImage(m_d->view->image());
-        }
+KisImageWSP KisCanvas2::image()
+{
+    return m_d->view->image();
 
-#ifdef HAVE_OPENGL
-    }
-#endif
-    emit imageChanged(m_d->view->image());
 }
 
-void KisCanvas2::disconnectCurrentImage()
+KisImageWSP KisCanvas2::currentImage()
 {
-#ifdef HAVE_OPENGL
-    if (m_d->openGLImageTextures) {
-        m_d->openGLImageTextures->disconnect(this);
-    }
-#endif
-    m_d->view->image()->disconnect(this);
+    return m_d->view->image();
 }
 
-void KisCanvas2::resetCanvas(bool useOpenGL)
+void KisCanvas2::setImageSize(qint32 w, qint32 h)
 {
-    KisConfig cfg;
-#if HAVE_OPENGL
-
-    if (   (useOpenGL != m_d->currentCanvasIsOpenGL)
-        || (   m_d->currentCanvasIsOpenGL
-               && (cfg.useOpenGLShaders() != m_d->currentCanvasUsesOpenGLShaders))) {
-
-        disconnectCurrentImage();
-        slotSetDisplayProfile(KoColorSpaceRegistry::instance()->profileByName(cfg.monitorProfile()));
-        if (useOpenGL) {
-#ifdef HAVE_OPENGL
-            createOpenGLCanvas();
-#else
-            warnKrita << "OpenGL requested while its not available, starting qpainter canvas";
-            createQPainterCanvas();
-#endif
-        } else {
-            createQPainterCanvas();
-        }
-        connectCurrentImage();
-    }
-
-    if (useOpenGL) {
-        m_d->openGLImageTextures->setMonitorProfile(monitorProfile());
-    } else {
-        if (image()) {
-            updateCanvasProjection(image()->bounds());
-        }
-    }
-#endif
-    m_d->canvasWidget->widget()->update();
+    if (m_d->prescaledProjection)
+        m_d->prescaledProjection->setImageSize(w, h);
 }
 
 void KisCanvas2::documentOffsetMoved(const QPoint &documentOffset)
@@ -443,12 +495,6 @@ void KisCanvas2::documentOffsetMoved(const QPoint &documentOffset)
     m_d->canvasWidget->documentOffsetMoved(documentOffset);
 }
 
-void KisCanvas2::preScale()
-{
-    if (!m_d->currentCanvasIsOpenGL && m_d->prescaledProjection)
-        m_d->prescaledProjection->preScale();
-}
-
 bool KisCanvas2::usingHDRExposureProgram()
 {
 #ifdef HAVE_OPENGL
@@ -551,11 +597,4 @@ bool KisCanvas2::handlePopupPaletteIsVisible(KoPointerEvent* e)
     return false;
 }
 
-void KisCanvas2::mirrorCanvas(bool enable)
-{
-    m_d->mirrorMode = enable;
-    updateCanvas();
-}
-
-
 #include "kis_canvas2.moc"
diff --git a/krita/ui/canvas/kis_canvas2.h b/krita/ui/canvas/kis_canvas2.h
index 4022ec9..cd2f3f8 100644
--- a/krita/ui/canvas/kis_canvas2.h
+++ b/krita/ui/canvas/kis_canvas2.h
@@ -29,6 +29,8 @@
 #include <kis_types.h>
 #include <KoPointerEvent.h>
 
+#include "kis_prescaled_projection.h"
+
 class KoToolProxy;
 class KoColorProfile;
 
@@ -118,10 +120,7 @@ public: // KoCanvasBase implementation
      */
     void preScale();
 
-    void connectCurrentImage();
-
-    void disconnectCurrentImage();
-
+    // FIXME:
     // Temporary! Either get the current layer and image from the
     // resource provider, or use this, which gets them from the
     // current shape selection.
@@ -148,14 +147,18 @@ signals:
 
     void favoritePaletteCalled(const QPoint&);
 
+    void sigCanvasCacheUpdated(KisUpdateInfoSP);
+
 public slots:
 
     /// Update the entire canvas area
     void updateCanvas();
 
-    /// The image projection has changed, now update the canvas
-    /// representation of it.
-    void updateCanvasProjection(const QRect & rc);
+    /// The image projection has changed, now start an update
+    /// of the canvas representation.
+    void startUpdateCanvasProjection(const QRect & rc);
+
+    void updateCanvasProjection(KisUpdateInfoSP info);
 
     void setImageSize(qint32 w, qint32 h);
 
@@ -191,21 +194,24 @@ private slots:
     void slotCanvasDestroyed(QWidget* w);
 
 public:
+//    friend class KisView2;
 
-    friend class KisView2;
-
+    // interface for KisView2 only
+    void connectCurrentImage();
+    void disconnectCurrentImage();
     void resetCanvas(bool useOpenGL);
 
-    KisCanvas2(const KisCanvas2&);
-
-    void createCanvas();
-    void createQPainterCanvas();
-    void createOpenGLCanvas();
     void createFavoriteResourceManager(KisPaintopBox*);
-
     KoFavoriteResourceManager* favoriteResourceManager();
     bool handlePopupPaletteIsVisible(KoPointerEvent *);
 
+private:
+    Q_DISABLE_COPY(KisCanvas2);
+
+    void createCanvas(bool useOpenGL);
+    void createQPainterCanvas();
+    void createOpenGLCanvas();
+
     /**
      * Returns a rect in widget pixels that is translated for document
      * offset, resolution and zoom and that is guaranteed to be inside
diff --git a/krita/ui/canvas/kis_image_patch.cpp b/krita/ui/canvas/kis_image_patch.cpp
new file mode 100644
index 0000000..163feda
--- /dev/null
+++ b/krita/ui/canvas/kis_image_patch.cpp
@@ -0,0 +1,146 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_image_patch.h"
+
+#include <QPainter>
+#include "kis_debug.h"
+
+#include <math.h>
+#include <qimageblitz.h>
+
+/****** Some helper functions *******/
+
+inline void scaleRect(QRectF &rc, qreal scaleX, qreal scaleY)
+{
+    qreal x, y, w, h;
+    rc.getRect(&x, &y, &w, &h);
+
+    x *= scaleX;
+    y *= scaleY;
+    w *= scaleX;
+    h *= scaleY;
+
+    rc.setRect(x, y, w, h);
+}
+
+inline void scaleRect(QRect &rc, qreal scaleX, qreal scaleY)
+{
+    qint32 x, y, w, h;
+    rc.getRect(&x, &y, &w, &h);
+
+    x *= scaleX;
+    y *= scaleY;
+    w *= scaleX;
+    h *= scaleY;
+
+    rc.setRect(x, y, w, h);
+}
+
+/*********** KisImagePatch ************/
+
+KisImagePatch::KisImagePatch()
+    : m_scaleX(0), m_scaleY(0)
+{
+}
+
+KisImagePatch::KisImagePatch(QRect imageRect, qint32 borderWidth,
+                             qreal scaleX, qreal scaleY)
+    : m_scaleX(scaleX),
+      m_scaleY(scaleY)
+{
+    // First we get unscaled rects
+    m_interestRect = QRectF(borderWidth, borderWidth,
+                            imageRect.width(), imageRect.height());
+    m_patchRect = imageRect.adjusted(-borderWidth, -borderWidth,
+                                     borderWidth, borderWidth);
+    // And then we scale them
+    scaleRect(m_interestRect, scaleX, scaleY);
+    scaleRect(m_patchRect, scaleX, scaleY);
+
+    dbgRender << "A new patch has been created:";
+    dbgRender << ppVar(scaleX) << ppVar(scaleY);
+    dbgRender << ppVar(m_interestRect);
+    dbgRender << ppVar(m_patchRect);
+}
+
+void KisImagePatch::setImage(QImage image)
+{
+    m_image = image;
+}
+
+QRect KisImagePatch::patchRect()
+{
+    return m_patchRect;
+}
+
+bool KisImagePatch::isValid()
+{
+    return !m_image.isNull();
+}
+
+void KisImagePatch::drawMe(QPainter &gc,
+                           const QRectF &dstRect,
+                           QPainter::RenderHints renderHints)
+{
+    gc.save();
+    gc.setCompositionMode(QPainter::CompositionMode_Source);
+    gc.setRenderHints(renderHints, true);
+    gc.drawImage(dstRect, m_image, m_interestRect);
+    gc.restore();
+
+    /**
+     * Just for debugging purposes
+     */
+    qreal scaleX = dstRect.width() / m_interestRect.width();
+    qreal scaleY = dstRect.height() / m_interestRect.height();
+    dbgRender << "## PATCH.DRAWME #####################";
+    dbgRender << ppVar(scaleX) << ppVar(scaleY);
+    dbgRender << ppVar(m_patchRect);
+    dbgRender << ppVar(m_interestRect);
+    dbgRender << ppVar(dstRect);
+    dbgRender << "## EODM #############################";
+}
+
+#define ceiledSize(sz) QSize(ceil((sz).width()), ceil((sz).height()))
+
+void KisImagePatch::prescaleWithBlitz(QRectF dstRect)
+{
+    qreal scaleX = dstRect.width() / m_interestRect.width();
+    qreal scaleY = dstRect.height() / m_interestRect.height();
+
+    QSize newImageSize = QSize(ceil(m_image.width() * scaleX),
+                               ceil(m_image.height() * scaleY));
+
+    // Calculating new _aligned_ scale
+    scaleX = qreal(newImageSize.width()) / m_image.width();
+    scaleY = qreal(newImageSize.height()) / m_image.height();
+
+    m_scaleX *= scaleX;
+    m_scaleY *= scaleY;
+    scaleRect(m_interestRect, scaleX, scaleY);
+
+    m_image = Blitz::smoothScale(m_image,
+                                 newImageSize,
+                                 Qt::IgnoreAspectRatio);
+
+    dbgRender << "## PATCH.PRESCALEBLITZ ############";
+    dbgRender << ppVar(scaleX) << ppVar(scaleY);
+    dbgRender << ppVar(newImageSize);
+    dbgRender << "## EOB ############################";
+}
diff --git a/krita/ui/canvas/kis_image_patch.h b/krita/ui/canvas/kis_image_patch.h
new file mode 100644
index 0000000..d8c4882
--- /dev/null
+++ b/krita/ui/canvas/kis_image_patch.h
@@ -0,0 +1,108 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_IMAGE_PATCH_H_
+#define KIS_IMAGE_PATCH_H_
+
+#include <QPainter>
+#include <QImage>
+#include <kis_types.h>
+
+
+class KisImagePatch
+{
+public:
+    /**
+     * A default constuctor initializing invalid patch
+     */
+    KisImagePatch();
+
+    /**
+     * Initializes a new patch with given values.
+     * Be careful, because the constructor does not fill
+     * QImage of the patch, as the patch rect is not known yet
+     *
+     * \see setImage
+     */
+    KisImagePatch(QRect imageRect, qint32 borderWidth,
+                  qreal scaleX, qreal scaleY);
+
+    /**
+     * Sets the image of the patch
+     * Should be called right after the constructor
+     * to finish initializing the object
+     */
+    void setImage(QImage image);
+
+    /**
+     * Returns the rect of KisImage covered by the image
+     * of the patch (in KisImage pixels)
+     *
+     * \see m_patchRect
+     */
+    QRect patchRect();
+
+    /**
+     * Draws an m_interestRect of the patch onto @gc
+     * By the way it fits this rect into @dstRect
+     * @renderHints are directly tranmitted to QPainter
+     */
+    void drawMe(QPainter &gc,
+                const QRectF &dstRect,
+                QPainter::RenderHints renderHints);
+
+    /**
+     * Prescales an interestRect a bit with Blitz
+     * It's usefulness is dispulable and should be
+     * tested, so - FIXME
+     */
+    void prescaleWithBlitz(QRectF dstRect);
+
+    /**
+     * Checks whether the patch can be used for drawing the image
+     */
+    bool isValid();
+
+private:
+    /**
+     * The scale of the image stored in the patch
+     */
+    qreal m_scaleX;
+    qreal m_scaleY;
+
+    /**
+     * The rect of KisImage covered by the image
+     * of the patch (in KisImage pixels)
+     */
+    QRect m_patchRect;
+
+    /**
+     * The rect that was requested during creation
+     * of the patch. It equals to patchRect withount
+     * borders
+     * These borders are introdused for more accurate
+     * smooth scaling to reduce border effects
+     * (IN m_image PIXELS, relative to m_image's topLeft);
+
+     */
+    QRectF m_interestRect;
+
+    QImage m_image;
+};
+
+#endif /* KIS_IMAGE_PATCH_H_ */
diff --git a/krita/ui/canvas/kis_image_pyramid.cpp b/krita/ui/canvas/kis_image_pyramid.cpp
index b04a5d8..4d32d71 100644
--- a/krita/ui/canvas/kis_image_pyramid.cpp
+++ b/krita/ui/canvas/kis_image_pyramid.cpp
@@ -23,9 +23,6 @@
 #include "kis_iterators_pixel.h"
 #include "kis_datamanager.h"
 
-// for toAlignedRectWorkaround()
-#include "kis_prescaled_projection.h"
-
 #include "kis_debug.h"
 
 //#define DEBUG_PYRAMID
@@ -131,7 +128,8 @@ void KisImagePyramid::setImage(KisImageWSP newImage)
 
         clearPyramid();
         setImageSize(m_originalImage->width(), m_originalImage->height());
-        setDirty(m_originalImage->projection()->exactBounds());
+        retrieveImageData(m_originalImage->projection()->exactBounds());
+        //TODO: check whether there is needed recalculateCache()
     }
 }
 
@@ -142,19 +140,27 @@ void KisImagePyramid::setImageSize(qint32 w, qint32 h)
     /* nothing interesting */
 }
 
-void KisImagePyramid::setDirty(const QRect &rc)
+void KisImagePyramid::updateCache(KisPPUpdateInfoSP info)
+{
+    retrieveImageData(info->dirtyImageRect);
+}
+
+void KisImagePyramid::retrieveImageData(const QRect &rect)
 {
     KisPaintDeviceSP originalProjection = m_originalImage->projection();
 
     KisPainter gc(m_pyramid[ORIGINAL_INDEX]);
     gc.setCompositeOp(m_monitorColorSpace->compositeOp(COMPOSITE_COPY));
     gc.setOpacity(OPACITY_OPAQUE_U8);
-    gc.bitBlt(rc.topLeft(), originalProjection, rc);
+    gc.bitBlt(rect.topLeft(), originalProjection, rect);
     gc.end();
+}
 
+void KisImagePyramid::recalculateCache(KisPPUpdateInfoSP info)
+{
     KisPaintDevice *src;
     KisPaintDevice *dst;
-    QRect currentSrcRect = rc;
+    QRect currentSrcRect = info->dirtyImageRect;
 
     for (int i = FIRST_NOT_ORIGINAL_INDEX; i < m_pyramidHeight; i++) {
         src = m_pyramid[i-1].data();
@@ -304,53 +310,27 @@ void KisImagePyramid::alignSourceRect(QRect& rect, qreal scale)
     dbgRender << "After alignment:\t" << rect;
 }
 
-KisImagePatch KisImagePyramid::getNearestPatch(qreal scaleX, qreal scaleY,
-        const QRect& requestedRect,
-        qint32 borderWidth)
+KisImagePatch KisImagePyramid::getNearestPatch(KisPPUpdateInfoSP info)
 {
-    qint32 index = findFirstGoodPlaneIndex(qMax(scaleX, scaleY),
-                                           requestedRect.size());
+    qint32 index = findFirstGoodPlaneIndex(qMax(info->scaleX, info->scaleY),
+                                           info->imageRect.size());
     qreal planeScale = SCALE_FROM_INDEX(index);
     qint32 alignment = 1 << index;
 
-    KisImagePatch patch;
-
-    patch.m_scaleX = planeScale;
-    patch.m_scaleY = planeScale;
-
-    alignByPow2Hi(borderWidth, alignment);
-
-    patch.m_interestRect = toFloatRectWorkaround(
-                               QRect(borderWidth, borderWidth,
-                                     requestedRect.width(),
-                                     requestedRect.height())
-                           );
-
-    QRect adjustedRect = requestedRect.adjusted(-borderWidth, -borderWidth,
-                         borderWidth, borderWidth);
-    patch.m_patchRect = adjustedRect;
-
-    scaleRect(patch.m_interestRect, planeScale, planeScale);
-    scaleRect(patch.m_patchRect, planeScale, planeScale);
-
-    patch.m_image = convertToQImageFast(m_pyramid[index],
-                                        patch.m_patchRect);
+    alignByPow2Hi(info->borderWidth, alignment);
 
-    dbgRender << ppVar(planeScale);
-    dbgRender << ppVar(patch.m_interestRect);
-    dbgRender << ppVar(patch.m_patchRect);
+    KisImagePatch patch(info->imageRect, info->borderWidth,
+                        planeScale, planeScale);
 
+    patch.setImage(convertToQImageFast(m_pyramid[index],
+                                       patch.patchRect()));
     return patch;
 }
 
-void KisImagePyramid::drawFromOriginalImage(QPainter& gc,
-        const QRect& imageRect,
-        const QRectF& viewportRect,
-        qint32 borderWidth,
-        QPainter::RenderHints renderHints)
+void KisImagePyramid::drawFromOriginalImage(QPainter& gc, KisPPUpdateInfoSP info)
 {
-    KisImagePatch patch = getNearestPatch(1, 1, imageRect, borderWidth);
-    patch.drawMe(gc, viewportRect, renderHints);
+    KisImagePatch patch = getNearestPatch(info);
+    patch.drawMe(gc, info->viewportRect, info->renderHints);
 }
 
 QImage KisImagePyramid::convertToQImageFast(KisPaintDeviceSP paintDevice,
